From ccc3d7b1517f99c91c12053804513b3f6d20c910 Mon Sep 17 00:00:00 2001
From: Sean Whitton <spwhitton@spwhitton.name>
Date: Thu, 11 Aug 2016 11:20:28 -0700
Subject: [PATCH] debcheckout: rewrite insecure alioth URIs

---
 debian/changelog       |  3 +++
 scripts/debcheckout.pl | 12 ++++++++++++
 2 files changed, 15 insertions(+)

diff --git a/debian/changelog b/debian/changelog
index 84c5def..88b5e0d 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -17,6 +17,9 @@ devscripts (2.16.7) UNRELEASED; urgency=medium
   [ Christoph Berg ]
   * origtargz: Fix unpacking of tarballs found in --path.
 
+  [ Sean Whitton ]
+  * debcheckout: Rewrite insecure alioth URIs to use HTTPS.
+
  -- Paul Wise <pabs@debian.org>  Fri, 15 Jul 2016 22:36:19 +0800
 
 devscripts (2.16.6) unstable; urgency=medium
diff --git a/scripts/debcheckout.pl b/scripts/debcheckout.pl
index e9327bd..a998096 100755
--- a/scripts/debcheckout.pl
+++ b/scripts/debcheckout.pl
@@ -525,6 +525,17 @@ sub munge_url($$)
     return $repo_url;
 }
 
+# Protect against out-of-date insecure alioth URIs.
+sub secure_url($)
+{
+    my ($repo_url) = @_;
+
+    $repo_url =~ s@^git://(anonscm|git)\.debian\.org/@https://anonscm.debian.org/git/@;
+    $repo_url =~ s@^http://(anonscm|git|hg|svn|arch|bzr)\.debian\.org/@https://anonscm.debian.org/@;
+
+    return $repo_url;
+}
+
 # Checkout a given repository in a given destination directory.
 sub checkout_repo($$$) {
     my ($repo_type, $repo_url, $destdir) = @_;
@@ -1088,6 +1099,7 @@ EOF
 	print "declared $repo_type repository at $repo_url\n";
 	$destdir = $pkg unless length $destdir;
     }
+    $repo_url = secure_url($repo_url);
     my $rc;
     if (@files) {
 	$rc = checkout_files($repo_type, $repo_url, $destdir, $browse_url);
-- 
2.8.1

